﻿/**
 * This javascript code gets all link tags on the loaded page and analyze if there is an attribute with target="_blank".
 * For each of these links will add "newtab:" in front of the url value of the href attribute.
 * Then in the shouldOverrideUrlLoading() method I check if url begins with "newtab:" string,
 * in which case I open a new tab.
 */

function clubAppLinkAction() {
    var allLinks = document.getElementsByTagName("a");
    if (allLinks) {
        var i;
        for (i=0; i<allLinks.length; i++) {
            var link = allLinks[i];
            var target = link.getAttribute("target");
            if (target && target == "_blank" && link.toString().subString(0,7) != "newtab:") {
                link.setAttribute("target","_self");
                link.href = "newtab:" + link.href;
            }
        }
    }
}