/**
 * Copyright (C) 2017 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var RE = {};
/*默认style*/
var allbold=false;
var allItalic=false;
var allforecolor='rgb(0,0,0)';
var allfontsize="4";
/*默认style*/
var selectionState=null;
RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0};

RE.editor = document.getElementById('editor');

document.addEventListener("selectionchange", function() { RE.backuprange(); });

// Initializations
RE.callback = function() {
//点击响应，设置style
  //  alert("callback");
      if(allbold){
            //     alert("allbold");
                 RE.isBold();
        }
        if(!allbold){
            //     alert("!-allbold");
                 RE.notBold();
         }
        if(allItalic){
          //   alert("allitalic");
             RE.isItalic();
         }
        if(!allItalic){
         //   alert("!-allItalic");
            RE.notItalic();
        }
        RE.setFontSize(allfontsize);
        RE.setTextColor(allforecolor);
       // alert(allfontsize);
      //  alert(allforecolor);
    window.location.href = "re-callback://" + encodeURIComponent(RE.getHtml());
}

RE.setHtml = function(contents) {
    RE.editor.innerHTML = decodeURIComponent(contents.replace(/\+/g, '%20'));
}

RE.getHtml = function() {
    return RE.editor.innerHTML;
}

RE.getText = function() {
    return RE.editor.innerText;
}

RE.setBaseTextColor = function(color) {
    RE.editor.style.color  = color;
}

RE.setBaseFontSize = function(size) {
    RE.editor.style.fontSize = size;
}

RE.setPadding = function(left, top, right, bottom) {
  RE.editor.style.paddingLeft = left;
  RE.editor.style.paddingTop = top;
  RE.editor.style.paddingRight = right;
  RE.editor.style.paddingBottom = bottom;
}

RE.setBackgroundColor = function(color) {
    document.body.style.backgroundColor = color;
}

RE.setBackgroundImage = function(image) {
    RE.editor.style.backgroundImage = image;
}

RE.setWidth = function(size) {
    RE.editor.style.minWidth = size;
}

RE.setHeight = function(size) {
    RE.editor.style.height = size;
}

RE.setTextAlign = function(align) {
    RE.editor.style.textAlign = align;
}

RE.setVerticalAlign = function(align) {
    RE.editor.style.verticalAlign = align;
}

RE.setPlaceholder = function(placeholder) {
    RE.editor.setAttribute("placeholder", placeholder);
}

RE.setInputEnabled = function(inputEnabled) {
    RE.editor.contentEditable = String(inputEnabled);
}

RE.undo = function() {
    document.execCommand('undo', false, null);
}

RE.redo = function() {
    document.execCommand('redo', false, null);
}

RE.setBold = function() {
    document.execCommand('bold', false, null);
}

RE.setItalic = function() {
    document.execCommand('italic', false, null);
}

RE.setSubscript = function() {
    document.execCommand('subscript', false, null);
}

RE.setSuperscript = function() {
    document.execCommand('superscript', false, null);
}

RE.setStrikeThrough = function() {
    document.execCommand('strikeThrough', false, null);
}

RE.setUnderline = function() {
    document.execCommand('underline', false, null);
}

RE.setBullets = function() {
    document.execCommand('insertUnorderedList', false, null);
}

RE.setNumbers = function() {
    document.execCommand('insertOrderedList', false, null);
}

RE.setTextColor = function(color) {
  //  RE.restorerange();
   // document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
   // document.execCommand("styleWithCSS", null, false);
   //修改颜色
    allforecolor=color;
}

RE.setTextBackgroundColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setFontSize = function(fontSize){
    document.execCommand("fontSize", false, fontSize);
          //修改字体
    allfontsize=fontSize;
}

RE.setHeading = function(heading) {
    document.execCommand('formatBlock', false, '<h'+heading+'>');
}

RE.setIndent = function() {
    document.execCommand('indent', false, null);
}

RE.setOutdent = function() {
    document.execCommand('outdent', false, null);
}

RE.setJustifyLeft = function() {
    document.execCommand('justifyLeft', false, null);
}

RE.setJustifyCenter = function() {
    document.execCommand('justifyCenter', false, null);
}

RE.setJustifyRight = function() {
    document.execCommand('justifyRight', false, null);
}

RE.setBlockquote = function() {
    document.execCommand('formatBlock', false, '<blockquote>');
}
//加入id的insertImage和insertEmoji方法
RE.insertImage = function(url, alt,id) {
    var html = '<img src="' + url + '" class=ueditor_img alt="' + alt + '" id="'+id+'" />';
    RE.insertHTML(html);
    if(id!="img"){
       scrollTo(id);
   }
}

RE.insertEmoji = function(url, alt, width, height,id) {
    var html = '<img src="' + url + '" alt="' + alt + '" height="' + height + '" width="' + width + '" id="'+id+'"/>';
    RE.insertHTML(html);
        scrollTo(id);
    document.getElementById(id).onclick=function(){
//        alert(id);
       placeCaretAtEnd(this);
    }
}
//RE.setFontSize = function(heading) {
//    var html = '<font size='+heading+'>&nbsp</font>';
//    RE.insertHTML(html);
//}
RE.insertVideo = function(url, alt) {
    var html = '<video src="' + url + '" controls="' + alt + '" />';
    RE.insertHTML(html);
}
RE.insertHTML = function(html) {
    RE.restorerange();
    document.execCommand('insertHTML', false, html);

     if(allbold){
            //     alert("allbold");
                 RE.isBold();
        }
        if(!allbold){
            //     alert("!-allbold");
                 RE.notBold();
         }
        if(allItalic){
          //   alert("allitalic");
             RE.isItalic();
         }
        if(!allItalic){
         //   alert("!-allItalic");
            RE.notItalic();
        }
        RE.setFontSize(allfontsize);
        RE.setTextColor(allforecolor);
}

RE.insertLink = function(url, title) {
    RE.restorerange();
    var sel = document.getSelection();
    if (sel.toString().length == 0) {
        document.execCommand("insertHTML",false,"<a href='"+url+"'>"+title+"</a>");
    } else if (sel.rangeCount) {
       var el = document.createElement("a");
       el.setAttribute("href", url);
       el.setAttribute("title", title);

       var range = sel.getRangeAt(0).cloneRange();
       range.surroundContents(el);
       sel.removeAllRanges();
       sel.addRange(range);
   }
    RE.callback();
}

RE.setTodo = function(text) {
    var html = '<input type="checkbox" name="'+ text +'" value="'+ text +'"/> &nbsp;';
    document.execCommand('insertHTML', false, html);
}

RE.prepareInsert = function() {
    RE.backuprange();
}

RE.backuprange = function(){
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
      var range = selection.getRangeAt(0);
      RE.currentSelection = {
          "startContainer": range.startContainer,
          "startOffset": range.startOffset,
          "endContainer": range.endContainer,
          "endOffset": range.endOffset};
    }
}

RE.restorerange = function(){
    //----- temporary used to fixed bug
    var currentFontSize = document.queryCommandValue('fontSize');
    var currentBoldState = document.queryCommandValue('bold');
    var currentItalicState = document.queryCommandValue('italic');
    // temporary used to fixed bug-------
    var selection = window.getSelection();
    selection.removeAllRanges();
    var range = document.createRange();
    range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);
    range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
    selection.addRange(range);
    //----- temporary used to fixed bug
    if(currentFontSize !== document.queryCommandValue('fontSize')) {
        document.execCommand("fontSize", false, currentFontSize);
    }
    if(currentBoldState !== document.queryCommandValue('bold')){
        document.execCommand('bold', false, null);
    }
    if(currentItalicState !== document.queryCommandValue('italic')) {
        document.execCommand('italic', false, null);
    }
    // temporary used to fixed bug-------
}

RE.enabledEditingItems = function(e) {
    var items = [];
    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }

    window.location.href = "re-state://" + encodeURI(items.join(','));
}

RE.focus = function() {
//focus时设置当前style
//alert("focusstart");
//old version
//    var range = document.createRange();
//    range.selectNodeContents(RE.editor);
//    range.collapse(false);
//    var selection = window.getSelection();
//    selection.removeAllRanges();
//    selection.addRange(range);
    RE.editor.focus();
//old version

//          if(allbold){
//                //     alert("allbold");
//                     RE.isBold();
//            }
//            if(!allbold){
//                //     alert("!-allbold");
//                     RE.notBold();
//             }
//            if(allItalic){
//              //   alert("allitalic");
//                 RE.isItalic();
//             }
//            if(!allItalic){
//             //   alert("!-allItalic");
//                RE.notItalic();
//            }
//            RE.setFontSize(allfontsize);
//            RE.setTextColor(allforecolor);
//alert("focusend");

}

RE.blurFocus = function() {
    RE.editor.blur();
}

RE.removeFormat = function() {
    document.execCommand('removeFormat', false, null);
}

// Event Listeners
RE.editor.addEventListener("input", RE.callback);
//old version
//RE.editor.addEventListener("keyup", function(e) {
//    var KEY_LEFT = 37, KEY_RIGHT = 39;
//    if (e.which == KEY_LEFT || e.which == KEY_RIGHT) {
//        RE.enabledEditingItems(e);
//    }
//});
//RE.editor.addEventListener("click", RE.enabledEditingItems);
//old version


RE.clicked = function(e){
//click 事件响应设置style
    selectionState=window.getSelection();
    var selectionString=selectionState.toString();
    if(selectionString.length>0){
    }else{
    if(allbold){
        //     alert("allbold");
             RE.isBold();
    }
    if(!allbold){
        //     alert("!-allbold");
             RE.notBold();
     }
    if(allItalic){
      //   alert("allitalic");
         RE.isItalic();
     }
    if(!allItalic){
     //   alert("!-allItalic");
        RE.notItalic();
    }
    RE.setFontSize(allfontsize);
    RE.setTextColor(allforecolor);
 //   alert(allforecolor);
     }
}
RE.editor.addEventListener("click",RE.clicked);

RE.isBold=function(){
//强制bold
         allbold=true;
             if(document.queryCommandState('bold')){
     //            alert("isbold");
             }else{
             document.execCommand('bold',false,null);
      //       alert("isboldelse");
             }
         }
RE.notBold=function(){
//强制not bold
          allbold=false;
           if(document.queryCommandState('bold')){
               document.execCommand('bold',false,null);
      //         alert("notbold");
            }else{
       //     alert("notboldelse");
            }
           }
RE.isItalic=function(){
//强制italic
         allItalic=true;
             if(document.queryCommandState('italic')){
        //         alert("isitalic");
             }else{
             document.execCommand('italic',false,null);
       //      alert("isitalicelse");
             }
         }
RE.notItalic=function(){
//强制not italic
          allItalic=false;
           if(document.queryCommandState('italic')){
               document.execCommand('italic',false,null);
            //   alert("notitalic");
            }else{
          //  alert("notitalicelse");
            }
           }

function placeCaretAtEnd(el) { //传入光标要去的jq节点对象,解决两个表情直接难以插入光标问题
　　el.focus();
　　if (typeof window.getSelection != "undefined" && typeof document.createRange != "undefined") {
　　　　var range = document.createRange();
　　　　range.selectNodeContents(el);
　　　　range.collapse(false);
　　　　var sel = window.getSelection();
　　　　sel.removeAllRanges();
　　　　sel.addRange(range);
　　} else if (typeof document.body.createTextRange != "undefined") {
　　　　var textRange = document.body.createTextRange();
　　　　textRange.moveToElementText(el);
　　　　textRange.collapse(false);
　　　　textRange.select();
　　}
}